Package writer2latex.latex.i18n

# Class I18n

java.lang.Object
writer2latex.latex.i18n.I18n

Direct Known Subclasses:
  `ClassicI18n`, `XeTeXI18n`

public abstract class I18n extends Object
This abstract class takes care of i18n in the LaTeX export. Since i18n is handled quite differently in LaTeX "Classic" and XeTeX, we use two different classes

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`bAlwaysUseDefaultLang`
`protected boolean`
`bGreekMath`
`protected LaTeXConfig`
`config`
`protected HashSet<String>`
`languages`
`protected OfficeReader`
`ofr`
`protected String`
`sDefaultCountry`
`protected String`
`sDefaultCTLCountry`
`protected String`
`sDefaultCTLLanguage`
`protected String`
`sDefaultLanguage`
`protected ReplacementTrie`
`stringReplace`

## Constructor Summary

Constructors
Constructor
Description
`I18n(OfficeReader ofr, LaTeXConfig config, ConverterPalette palette)`
Construct a new I18n as ConverterHelper

## Method Summary

Modifier and Type
Method
Description
`abstract void`
`appendDeclarations(LaTeXDocumentPortion pack, LaTeXDocumentPortion decl)`
Add declarations to the preamble to load the required packages
`abstract void`
`applyLanguage(StyleWithProperties style, boolean bDecl, boolean bInherit, BeforeAfter ba)`
Apply a language language
`abstract String`
`convert(String s, boolean bMathMode, String sLang)`
Convert a string of characters into LaTeX
`String`
`getDefaultCountry()`
Get the default country
`String`
`getDefaultLanguage()`
Get the default language (either the document language or the most used language)
`abstract void`
`popSpecialTable()`
Pop a font from the font stack
`abstract void`
`pushSpecialTable(String sName)`
Push a font to the font stack

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### ofr

protected OfficeReader ofr

### config

protected LaTeXConfig config

### stringReplace

protected ReplacementTrie stringReplace

### bGreekMath

protected boolean bGreekMath

### bAlwaysUseDefaultLang

protected boolean bAlwaysUseDefaultLang

### sDefaultCTLLanguage

protected String sDefaultCTLLanguage

### sDefaultCTLCountry

protected String sDefaultCTLCountry

### sDefaultLanguage

protected String sDefaultLanguage

### sDefaultCountry

protected String sDefaultCountry

### languages

protected HashSet<String> languages

## Constructor Details

### I18n

public I18n(OfficeReader ofr, LaTeXConfig config, ConverterPalette palette)
Construct a new I18n as ConverterHelper

Parameters:
  `ofr` - the OfficeReader to get language information from
  `config` - the configuration which determines the symbols to use
  `palette` - the ConverterPalette (unused)

## Method Details

### appendDeclarations

public abstract void appendDeclarations(LaTeXDocumentPortion pack, LaTeXDocumentPortion decl)
Add declarations to the preamble to load the required packages

Parameters:
  `pack` - usepackage declarations
  `decl` - other declarations

### applyLanguage

public abstract void applyLanguage(StyleWithProperties style, boolean bDecl, boolean bInherit, BeforeAfter ba)
Apply a language language

Parameters:
  `style` - the OOo style to read attributes from
  `bDecl` - true if declaration form is required
  `bInherit` - true if inherited properties should be used
  `ba` - the `BeforeAfter` to add LaTeX code to.

### pushSpecialTable

public abstract void pushSpecialTable(String sName)
Push a font to the font stack

Parameters:
  `sName` - the name of the font

### popSpecialTable

public abstract void popSpecialTable()
Pop a font from the font stack

### convert

public abstract String convert(String s, boolean bMathMode, String sLang)
Convert a string of characters into LaTeX

Parameters:
  `s` - the source string
  `bMathMode` - true if the string should be rendered in math mode
  `sLang` - the ISO language of the string
Returns:
  the LaTeX string

### getDefaultLanguage

public String getDefaultLanguage()
Get the default language (either the document language or the most used language)

Returns:
  the default language

### getDefaultCountry

public String getDefaultCountry()
Get the default country

Returns:
  the default country